#!/bin/bash

if [[ -z $1 ]]; then {
    read -a SERVERNAME -p "servername: "
} else {
    SERVERNAME=$1
}
fi

if [[ -z $2 ]]; then {
    read -a USERNAME -p "username: "
} else {
    USERNAME=$2
}
fi

# Step1 - run on your local computer.
if [ ! -f ~/.ssh/id_rsa ]; then
	ssh-keygen -t rsa -b 2048 -f ~/.ssh/id_rsa -C "Key for ssh"
fi
#echo ""

# Step2 - run on your local computer
chmod 700 ~/.ssh && chmod 600 ~/.ssh/*
#echo ""

# Step3 - run on your local computer (against the remote server)
cat ~/.ssh/id_rsa.pub | ssh $USERNAME@$SERVERNAME 'if [ ! -d ~/.ssh ]; then  mkdir ~/.ssh; fi; cat - >> ~/.ssh/authorized_keys; chmod 600 ~/.ssh/authorized_keys && chmod 700 ~/.ssh; cat ~/.ssh/authorized_keys | sort -u > ~/.ssh/authorized_keys_unique; cp ~/.ssh/authorized_keys_unique ~/.ssh/authorized_keys'
if [ $? != 0 ]; then {
	exit 1
}
fi

#Step4 - echo connection string (rather mouse clicks than type :))
echo "To connect type: ssh $USERNAME@$SERVERNAME"
